<?php
/**
 * +----------------------------------------------------------------------
 * 微服务-配置调用类
 * +----------------------------------------------------------------------
 * 官网：https://www.sw-x.cn
 * +----------------------------------------------------------------------
 * 作者：小黄牛 <1731223728@qq.com>
 * +----------------------------------------------------------------------
 * 开源协议：http://www.apache.org/licenses/LICENSE-2.0
 * +----------------------------------------------------------------------
*/

namespace SwooleXRpc;

class Rpc
{
    private static $instance = null; // 创建静态对象变量,用于存储唯一的对象实例  
    private function __construct(){} // 私有化构造函数，防止外部调用
    private function __clone(){}     // 私有化克隆函数，防止外部克隆对象
    private static $config; // 配置

    /**
     * 实例化对象方法，供外部获得唯一的对象
    */
    public static function run(){
        if (empty(self::$instance)) {
            require_once dirname(__FILE__).'/lifecycle/rpc_error.php';
            self::$config = require dirname(__FILE__).'/config/rpc.php';
            self::$instance = new \SwooleXRpc\Rpc();
        }
        return self::$instance;
    }

    /**
     * 当检测失败时，回调的处理函数
     * @todo 无
     * @author 小黄牛
     * @version v1.2.24 + 2021.1.9
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public static function ping_error($config, $status) {
        rpc_error($config['class'], $config['function'], $config, $status);
        return false;
    }

    /**
     * 读取配置
     * @todo 无
     * @author 小黄牛
     * @version v1.2.24 + 2021.1.9
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public static function get($class, $function) {
        $redis_key = self::$config['redis_key'];
        $set_key = '_sets_'.md5($class.$function);
        $array = \SwooleXRpc\RpcRedis::run()->SMEMBERS($redis_key.$set_key);
        $list = array();
        // 读取全部节点
        foreach ($array as $key) {
            $val = \SwooleXRpc\RpcRedis::run()->hGetAll($redis_key.$key);
            if ($val) {
                $md5 = md5($val['class'].$val['function'].$val['ip'].$val['port']);
                $score_key = '_score_'.$md5;
                $peaks_key = '_peaks_'.$md5;
                $num_key = '_num_'.$md5;
                
                $val['ping_ms'] = \SwooleXRpc\RpcRedis::run()->get($redis_key.$peaks_key);
                $val['score'] = \SwooleXRpc\RpcRedis::run()->get($redis_key.$score_key);
                $val['request_num'] = \SwooleXRpc\RpcRedis::run()->get($redis_key.$num_key);
                
                $list[] = $val;
            }
        }

        return $list;
    }

    /**
     * 更新单条配置
     * @todo 无
     * @author 小黄牛
     * @version v1.2.24 + 2021.1.9
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public static function set($config) {
        $md5 = md5($config['class'].$config['function'].$config['ip'].$config['port']);
        $hash_key = '_hash_'.$md5;
        $res = \SwooleXRpc\RpcRedis::run()->HMSET(self::$config['redis_key'].$hash_key, $config);
        return $res;
    }
    
}